#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "main.h"

void
on_goto_selected1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_help1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_file1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_new2_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_load_positions1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save_positions1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save_positions_as1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *window_preferences = create_window_preferences ();
  gtk_widget_show (window_preferences);
}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_exit (0);
}


void
on_edit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_delete1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save_current_servo_positions1_activate
                                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *widget = create_window_ins_pos ();
  gtk_widget_show (widget);
}


void
on_insert_delay1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_reset_all_servo_positions1_activate (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_reset_all_servo_settings1_activate  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_run_forward1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_run_backward1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_stop1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_step_forward1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_step_backward1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about_servo_controller1_activate    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *window_about = create_window_about ();
  gtk_widget_show (window_about);
}


void
on_about_button_close_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_hide (widget);
  gtk_widget_destroy (widget);
}


void
on_preferences_button_cancel_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_hide (widget);
  gtk_widget_destroy (widget);
}


void
on_preferences_button_ok_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_hide (widget);
  gtk_widget_destroy (widget);
}



/***************************************************************/
/* Servo values changed: either by spin button or home button. */
/***************************************************************/


void
on_window_main_servo_1_value_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{
  gint tmpval = gtk_spin_button_get_value_as_int(window_main_servo_0_value);
  if(tmpval != servo_0_value){
    servo_0_value = tmpval;
    if(gtk_toggle_button_get_active(window_main_servo_0_active))
      servo_send_position (0,servo_0_value);
  }
}


void
on_window_main_button_servo_1_home_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  if(servo_0_value != servo_0_home){
    servo_0_value = servo_0_home;
    gtk_spin_button_set_value(window_main_servo_0_value,servo_0_home);
    if(gtk_toggle_button_get_active(window_main_servo_0_active))
      servo_send_position(0,servo_0_value);
  }
}


void
on_window_main_servo_2_value_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{
  gint tmpval = gtk_spin_button_get_value_as_int(window_main_servo_1_value);
  if(tmpval != servo_1_value){
    servo_1_value = tmpval;
    if(gtk_toggle_button_get_active(window_main_servo_1_active))
      servo_send_position (1,servo_1_value);
  }
}


void
on_window_main_button_servo_2_home_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  if(servo_1_value != servo_1_home){
    servo_1_value=servo_1_home;
    gtk_spin_button_set_value(window_main_servo_1_value,servo_1_home);
    if(gtk_toggle_button_get_active(window_main_servo_1_active))
      servo_send_position(1,servo_1_value);
  }
}


void
on_window_main_servo_3_value_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{
  gint tmpval = gtk_spin_button_get_value_as_int(window_main_servo_2_value);
  if(tmpval != servo_2_value){
    servo_2_value = tmpval;
    if(gtk_toggle_button_get_active(window_main_servo_2_active))
      servo_send_position (2,servo_2_value);
  }
}


void
on_window_main_button_servo_3_home_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  if(servo_2_value != servo_2_home){
    servo_2_value=servo_2_home;
    gtk_spin_button_set_value(window_main_servo_2_value,servo_2_home);
    if(gtk_toggle_button_get_active(window_main_servo_2_active))
      servo_send_position(2,servo_2_value);
  }
}


void
on_window_main_servo_4_value_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{
  gint tmpval = gtk_spin_button_get_value_as_int(window_main_servo_3_value);
  if(tmpval != servo_3_value){
    servo_3_value = tmpval;
    if(gtk_toggle_button_get_active(window_main_servo_3_active))
      servo_send_position (3,servo_3_value);
  }
}


void
on_window_main_button_servo_4_home_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  if(servo_3_value != servo_3_home){
    servo_3_value=servo_3_home;
    gtk_spin_button_set_value(window_main_servo_3_value,servo_3_home);
    if(gtk_toggle_button_get_active(window_main_servo_3_active))
      servo_send_position(3,servo_3_value);
  }
}


void
on_window_main_servo_5_value_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{
  gint tmpval = gtk_spin_button_get_value_as_int(window_main_servo_4_value);
  if(tmpval != servo_4_value){
    servo_4_value = tmpval;
    if(gtk_toggle_button_get_active(window_main_servo_4_active))
      servo_send_position (4,servo_4_value);
  }
}


void
on_window_main_button_servo_5_home_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  if(servo_4_value != servo_4_home){
    servo_4_value=servo_4_home;
    gtk_spin_button_set_value(window_main_servo_4_value,servo_4_home);
    if(gtk_toggle_button_get_active(window_main_servo_4_active))
      servo_send_position(4,servo_4_value);
  }
}


void
on_window_main_servo_6_value_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{
  gint tmpval = gtk_spin_button_get_value_as_int(window_main_servo_5_value);
  if(tmpval != servo_5_value){
    servo_5_value = tmpval;
    if(gtk_toggle_button_get_active(window_main_servo_5_active))
      servo_send_position (5,servo_5_value);
  }
}


void
on_window_main_button_servo_6_home_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  if(servo_5_value != servo_5_home){
    servo_5_value=servo_5_home;
    gtk_spin_button_set_value(window_main_servo_5_value,servo_5_home);
    if(gtk_toggle_button_get_active(window_main_servo_5_active))
      servo_send_position(5,servo_5_value);
  }
}


void
on_window_main_servo_7_value_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{
  gint tmpval = gtk_spin_button_get_value_as_int(window_main_servo_6_value);
  if(tmpval != servo_6_value){
    servo_6_value = tmpval;
    if(gtk_toggle_button_get_active(window_main_servo_6_active))
      servo_send_position (6,servo_6_value);
  }
}


void
on_window_main_button_servo_7_home_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  if(servo_6_value != servo_6_home){
    servo_6_value=servo_6_home;
    gtk_spin_button_set_value(window_main_servo_6_value,servo_6_home);
    if(gtk_toggle_button_get_active(window_main_servo_6_active))
      servo_send_position(6,servo_6_value);
  }
}


void
on_window_main_servo_8_value_changed   (GtkEditable     *editable,
                                        gpointer         user_data)
{
  gint tmpval = gtk_spin_button_get_value_as_int(window_main_servo_7_value);
  if(tmpval != servo_7_value){
    servo_7_value = tmpval;
    if(gtk_toggle_button_get_active(window_main_servo_7_active))
      servo_send_position (7,servo_7_value);
  }
}


void
on_window_main_button_servo_8_home_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  if(servo_7_value != servo_7_home){
    servo_7_value=servo_7_home;
    gtk_spin_button_set_value(window_main_servo_7_value,servo_7_home);
    if(gtk_toggle_button_get_active(window_main_servo_7_active))
      servo_send_position(7,servo_7_value);
  }
}


void
on_window_ins_pos_cancel_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_window_ins_pos_ok_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_window_ins_del_cancel_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_window_ins_del_ok_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_window_fileselector_button_ok_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget
    = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  file_filename
    = gtk_file_selection_get_filename (GTK_FILE_SELECTION(user_data));
  file_loaded = TRUE;
  printf("Selected: %s\n",file_filename);
  gtk_entry_set_text (GTK_ENTRY (window_preferences_serial_entry),
		      file_filename);
  gtk_widget_hide (widget);
  gtk_widget_destroy (widget);
}


void
on_window_fileselector_button_cancel_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_hide (widget);
  gtk_widget_destroy (widget);
}


void
on_window_preferences_button_browse_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = create_window_fileselector ();
  gtk_widget_show (widget);
}

