#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "main.h"

void
on_goto_selected1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_help1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_file1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_new2_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_load_positions1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save_positions1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_save_positions_as1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *window_preferences = create_window_preferences ();
  gtk_widget_show (window_preferences);
}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_exit (0);
}


void
on_edit_row_activate                      (GtkMenuItem     *menuitem,
					   gpointer         user_data)
{
  gchar *type_text,*servo_text,*position_text,*delay_text,*note_text;
  gfloat gfservo,gfposition,gfdelay;

  gint res;
  GtkWidget *window_edit_pos;
  res = gtk_clist_get_text(window_main_clist,clist_selected_row,0,
			   &type_text);
  res = gtk_clist_get_text(window_main_clist,clist_selected_row,1,
			   &servo_text);
  res = gtk_clist_get_text(window_main_clist,clist_selected_row,2,
			   &position_text);
  res = gtk_clist_get_text(window_main_clist,clist_selected_row,3,
			   &delay_text);
  res = gtk_clist_get_text(window_main_clist,clist_selected_row,4,
			   &note_text);
  gfservo = atof(servo_text);
  gfposition = atof(position_text);
  gfdelay = atof(delay_text);
  if(strcmp(type_text,"Servo") == 0){
    edit_is_servo = TRUE;
    window_edit_pos = create_window_edit_pos(0,gfservo,gfposition,gfdelay,note_text);
  }
  if(strcmp(type_text,"Delay") == 0){
    edit_is_servo = FALSE;
    window_edit_pos = create_window_edit_pos(1,gfservo,gfposition,gfdelay,note_text);
  }
  gtk_widget_show (window_edit_pos);
}


void
on_delete_row_activate                       (GtkMenuItem     *menuitem,
					      gpointer         user_data)
{
  gtk_clist_freeze(GTK_CLIST(window_main_clist));
  // gtk_clist_unselect_row(GTK_CLIST(window_main_clist),clist_selected_row,0);
  gtk_clist_remove(GTK_CLIST(window_main_clist),clist_selected_row);
  gtk_clist_thaw(GTK_CLIST(window_main_clist));
}




/*********************************************************************/
/* Display dialog for "insert current servo positions".              */
/*********************************************************************/


void
on_save_current_servo_positions1_activate
                                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gchar strtxt[200];
  gchar window_ins_pos_txt[600];
  gint window_ins_pos_end = 0;
  gint i;
  GtkWidget *window_ins_pos = create_window_ins_pos ();
  sprintf(window_ins_pos_txt,"These positions will be saved:\n\n");
  for(i=0;i<=7;i++){
    if(servo_active[i]){
      sprintf(strtxt,"Servo %d: %d\n", i, servo_value[i]);
      strcat(window_ins_pos_txt,strtxt);
    }
  }
  sprintf(strtxt,"\nYou can make a note below, for help.\n\n");
  strcat(window_ins_pos_txt,strtxt);
  gtk_editable_insert_text (GTK_EDITABLE(window_ins_pos_textarea),
			    window_ins_pos_txt,
			    strlen(window_ins_pos_txt),
			    &window_ins_pos_end);
  printf("New end position: %d\n",window_ins_pos_end);
  gtk_widget_show (window_ins_pos);
}


void
on_insert_delay1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *window_ins_delay = create_window_ins_delay();
  gtk_widget_show(window_ins_delay);
}


void
on_reset_all_servo_positions1_activate (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_reset_all_servo_settings1_activate  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_run_forward1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_run_backward1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_stop1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_step_forward1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_step_backward1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about_servo_controller1_activate    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *window_about = create_window_about ();
  gtk_widget_show (window_about);
}


void
on_about_button_close_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_hide (widget);
  gtk_widget_destroy (widget);
}


void
on_preferences_button_cancel_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_hide (widget);
  gtk_widget_destroy (widget);
}


void
on_preferences_button_ok_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_hide (widget);
  gtk_widget_destroy (widget);
}



/***************************************************************/
/* Servo values changed: either by spin button or home button. */
/***************************************************************/


void on_window_main_servo_value_changed
(GtkEditable *editable, gpointer user_data)
{
  gint spinval;
  GtkWidget *swidget, *bwidget;
  switch(GPOINTER_TO_INT(user_data)){
  case 0:
    swidget = window_main_servo_0_value;
    bwidget = window_main_servo_0_active;
    break;
  case 1:
    swidget = window_main_servo_1_value;
    bwidget = window_main_servo_1_active;
    break;
  case 2:
    swidget = window_main_servo_2_value;
    bwidget = window_main_servo_2_active;
    break;
  case 3:
    swidget = window_main_servo_3_value;
    bwidget = window_main_servo_3_active;
    break;
  case 4:
    swidget = window_main_servo_4_value;
    bwidget = window_main_servo_4_active;
    break;
  case 5:
    swidget = window_main_servo_5_value;
    bwidget = window_main_servo_5_active;
    break;
  case 6:
    swidget = window_main_servo_6_value;
    bwidget = window_main_servo_6_active;
    break;
  case 7:
    swidget = window_main_servo_7_value;
    bwidget = window_main_servo_7_active;
    break;
  default:
    break;
  }
  spinval = gtk_spin_button_get_value_as_int(swidget);
  if(spinval != servo_value[GPOINTER_TO_INT(user_data)]){
    servo_value[GPOINTER_TO_INT(user_data)] = spinval;
    if(gtk_toggle_button_get_active(bwidget))
      servo_send_position (GPOINTER_TO_INT(user_data),
			   servo_value[GPOINTER_TO_INT(user_data)]);
  }
}


void on_window_main_button_servo_home_clicked
(GtkButton *button, gpointer user_data)
{
  gint spinval;
  GtkWidget *swidget, *bwidget;
  switch(GPOINTER_TO_INT(user_data)){
  case 0:
    swidget = window_main_servo_0_value;
    bwidget = window_main_servo_0_active;
    break;
  case 1:
    swidget = window_main_servo_1_value;
    bwidget = window_main_servo_1_active;
    break;
  case 2:
    swidget = window_main_servo_2_value;
    bwidget = window_main_servo_2_active;
    break;
  case 3:
    swidget = window_main_servo_3_value;
    bwidget = window_main_servo_3_active;
    break;
  case 4:
    swidget = window_main_servo_4_value;
    bwidget = window_main_servo_4_active;
    break;
  case 5:
    swidget = window_main_servo_5_value;
    bwidget = window_main_servo_5_active;
    break;
  case 6:
    swidget = window_main_servo_6_value;
    bwidget = window_main_servo_6_active;
    break;
  case 7:
    swidget = window_main_servo_7_value;
    bwidget = window_main_servo_7_active;
    break;
  default:
    break;
  }
  if(servo_value[GPOINTER_TO_INT(user_data)]
     != servo_home[GPOINTER_TO_INT(user_data)]){
    servo_value[GPOINTER_TO_INT(user_data)]
      = servo_home[GPOINTER_TO_INT(user_data)];
    gtk_spin_button_set_value(swidget,servo_home[GPOINTER_TO_INT(user_data)]);
    if(gtk_toggle_button_get_active(bwidget))
      servo_send_position(GPOINTER_TO_INT(user_data),
			  servo_value[GPOINTER_TO_INT(user_data)]);
  }
}

/*
 * An "active" toggle button is toggled, check the state
 * and copy to the neccessary servo_active register.
 */

void on_window_main_servo_active_toggled
(GtkButton *button, gpointer user_data)
{
  GtkWidget *bwidget;
  switch(GPOINTER_TO_INT(user_data)){
  case 0:
    bwidget = window_main_servo_0_active;
    break;
  case 1:
    bwidget = window_main_servo_1_active;
    break;
  case 2:
    bwidget = window_main_servo_2_active;
    break;
  case 3:
    bwidget = window_main_servo_3_active;
    break;
  case 4:
    bwidget = window_main_servo_4_active;
    break;
  case 5:
    bwidget = window_main_servo_5_active;
    break;
  case 6:
    bwidget = window_main_servo_6_active;
    break;
  case 7:
    bwidget = window_main_servo_7_active;
    break;
  default:
    break;
  }
  if(gtk_toggle_button_get_active(bwidget)){
    servo_active[GPOINTER_TO_INT(user_data)] = TRUE;
  }
  else{
    servo_active[GPOINTER_TO_INT(user_data)] = FALSE;  
  }
}



/***********************************************************/
/* Window insert current servo positions button callbacks. */
/***********************************************************/


void
on_window_ins_pos_cancel_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_destroy (widget);
}

/*
 *  Insert positions into clist.
 */

void
on_window_ins_pos_ok_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  gint i;
  gchar *strings[5];
  gchar *tmptitle = malloc(255*sizeof(gchar));
  gchar *tmp1 = malloc(255*sizeof(gchar));
  gchar *tmp2 = malloc(255*sizeof(gchar));
  GtkWidget *widget = gtk_widget_get_ancestor (GTK_WIDGET(button),GTK_TYPE_WINDOW);

  /* If this is our first change to the project */

  if(!project_changed){
    project_changed = TRUE;
    if(file_loaded){
      sprintf(tmp1,"miniSSC terminal: *%s",file_filename);
      gtk_window_set_title (GTK_WINDOW(window_main),tmptitle);
    }else{
      gtk_window_set_title (GTK_WINDOW(window_main),
			    "miniSSC terminal: *Untitled");
    }
  }

  gtk_clist_freeze(GTK_CLIST(window_main_clist));
  for(i=0;i<=7;i++){
    if(servo_active[i]){
      sprintf(tmp1,"%d",i);
      sprintf(tmp2,"%d",servo_value[i]);
      strings[0] = strdup("Servo");
      strings[1] = strdup(tmp1);
      strings[2] = strdup(tmp2);
      strings[3] = strdup("");
      strings[4] = gtk_entry_get_text(GTK_ENTRY(window_ins_pos_note_entry));
      /* Insert on selected row, if one is selected */
      if(clist_row_is_selected)
	clist_end_row = gtk_clist_insert (GTK_CLIST(window_main_clist),
					  clist_selected_row,strings);
      /* Append to end of list */
      else
	clist_end_row = gtk_clist_append (GTK_CLIST(window_main_clist),strings);
    }
  }
  gtk_clist_thaw(GTK_CLIST(window_main_clist));
  gtk_widget_destroy (widget);
}



/**********************************/
/* Insert delay dialog callbacks. */
/**********************************/


void
on_window_ins_del_cancel_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_destroy(widget);
}


void
on_window_ins_del_ok_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  gchar *strings[5];
  gchar *tmp;
  GtkWidget *widget = gtk_widget_get_ancestor (GTK_WIDGET(button),
					       GTK_TYPE_WINDOW);
  gint sec = gtk_spin_button_get_value_as_int(window_ins_delay_seconds);
  gchar *note = gtk_entry_get_text(GTK_ENTRY(window_ins_delay_note_entry));

  gtk_clist_freeze(GTK_CLIST(window_main_clist));
  sprintf(tmp,"%d",sec);
  strings[0] = strdup("Delay");
  strings[1] = strdup("");
  strings[2] = strdup("");
  strings[3] = strdup(tmp);
  strings[4] = strdup(note);
  clist_end_row = gtk_clist_append (GTK_CLIST(window_main_clist),strings);
  gtk_clist_thaw(GTK_CLIST(window_main_clist));
  gtk_widget_destroy (widget);
}


void
on_window_fileselector_button_ok_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  file_filename = gtk_file_selection_get_filename
    (GTK_FILE_SELECTION(user_data));
  file_loaded = TRUE;
  printf("Selected: %s\n",file_filename);
  gtk_entry_set_text (GTK_ENTRY (window_preferences_serial_entry),
		      file_filename);
  gtk_widget_destroy (widget);
}


void
on_window_fileselector_button_cancel_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_destroy (widget);
}


void
on_window_preferences_button_browse_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = create_window_fileselector ();
  gtk_widget_show (widget);
}


void
on_window_main_clist_select_row (GtkCList *clist, gint row, gint column,
				 GdkEventButton *bevent, gpointer data)
{
  clist_row_is_selected = TRUE;
  clist_selected_row = row;
  gtk_widget_set_sensitive(GTK_WIDGET(menu_edit_edit),TRUE);
  gtk_widget_set_sensitive(GTK_WIDGET(menu_edit_delete),TRUE);
}

void
on_window_main_clist_unselect_row (GtkCList *clist, gint row, gint column,
				   GdkEventButton *bevent, gpointer data)
{
  clist_row_is_selected = FALSE;
  gtk_widget_set_sensitive(GTK_WIDGET(menu_edit_edit),FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(menu_edit_delete),FALSE);
}



/**** Edit row, now save into clist ****/

void
on_window_edit_pos_ok_clicked           (GtkButton       *button,
					 gpointer         user_data)
{
  gchar *newnote = malloc(255*sizeof(gchar));
  gchar *tmp1 = malloc(15*sizeof(gchar));
  gchar *tmp2 = malloc(15*sizeof(gchar));
  gchar *strings[5];
  gint newservo,newpos,newsec;
  GtkWidget *widget = gtk_widget_get_ancestor (GTK_BUTTON(button),
					       GTK_TYPE_WINDOW);
  newservo = gtk_spin_button_get_value_as_int(GTK_OBJECT(window_edit_pos_servo));
  newpos = gtk_spin_button_get_value_as_int(GTK_OBJECT(window_edit_pos_position));
  newsec = gtk_spin_button_get_value_as_int(GTK_OBJECT(window_edit_pos_seconds));
  newnote = gtk_entry_get_text(GTK_ENTRY(window_edit_pos_entry));
  /*  printf("newservo=%d\nnewpos=%d\nnewsec=%d\nnewnote=%s\n\n",
      newservo,newpos,newsec,newnote); */
  if(edit_is_servo){
    sprintf(tmp1,"%d",newservo);
    sprintf(tmp2,"%d",newpos);
    strings[0] = strdup("Servo");
    strings[1] = strdup(tmp1);
    strings[2] = strdup(tmp2);
    strings[3] = strdup("");
    strings[4] = strdup(newnote);
  }else{
    sprintf(tmp1,"%d",newsec);
    strings[0] = strdup("Delay");
    strings[1] = strdup("");
    strings[2] = strdup("");
    strings[3] = strdup(tmp1);
    strings[4] = strdup(newnote);
  }
  gtk_clist_set_text (GTK_CLIST(window_main_clist),
		      clist_selected_row,0,strings[0]);
  gtk_clist_set_text (GTK_CLIST(window_main_clist),
		      clist_selected_row,1,strings[1]);
  gtk_clist_set_text (GTK_CLIST(window_main_clist),
		      clist_selected_row,2,strings[2]);
  gtk_clist_set_text (GTK_CLIST(window_main_clist),
		      clist_selected_row,3,strings[3]);
  gtk_clist_set_text (GTK_CLIST(window_main_clist),
		      clist_selected_row,4,strings[4]);
  gtk_widget_destroy(widget);
}


/**** Cancel edit row *****/

void
on_window_edit_pos_cancel_clicked       (GtkButton       *button,
					 gpointer         user_data)
{
  GtkWidget *widget = gtk_widget_get_ancestor (button,GTK_TYPE_WINDOW);
  gtk_widget_destroy(widget);
}

