/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 *
 * Servo Controller -- Possible name: miniSSC controller,
 * because that is what it really is.
 *
 * (c) 2002 Rolf Johansson, <rojo at nocrew dot org>.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"

/* Global variables. */

gchar *file_filename;                  /* The name of a loaded file. */
gint file_loaded = FALSE;              /* Is a file loaded? */
gint communications_ok = FALSE;        /* Does the comm work? */
gchar *usermsg = "Waiting.";           /* User status message. */

/* Servo values: active, current value and home positions. */

gint servo_active[] = { FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,FALSE };
gint servo_value[] = { 0, 0, 0, 0, 0, 0, 0, 0 };
gint servo_home[]  = { 100, 101, 102, 103, 104, 105, 106, 107 };

gint clist_end_row = 0;
gint clist_row_is_selected = FALSE;
gint clist_selected_row = 0;

gint edit_is_servo = FALSE;

gint project_changed = FALSE;

GtkWidget *window_main;
GtkWidget *window_about;
GtkWidget *window_splash;
GtkWidget *window_preferences;
GtkWidget *window_preferences_serial_entry;

int
main (int argc, char *argv[])
{
  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

  /* Create the interface windows. */

  window_main = create_window_main ();

  /* Start by showing the main window. */

  gtk_widget_show (window_main);

  /* Main iteration. */

  gtk_main ();
  return 0;
}

void servo_send_position (gint snr, gint spos)
{
  guint sbc, sbcn;
  gchar msg[200];
  sprintf(msg,"Sent serial data for servo %d, position %d.", snr, spos);
  printf("255,%d,%d\n", snr, spos);
  sbc = gtk_statusbar_get_context_id (GTK_STATUSBAR(window_main_statusbar),
				      "General");
  sbcn = gtk_statusbar_push (GTK_STATUSBAR(window_main_statusbar), sbc, msg);
}
